	data(Golub_Train)
	x.all = exprs(Golub_Train)
	f = function(t) {
		t.test(t)$p.value
	}
	x = t(x.all[order(apply(x.all, 1, f))[1:200], ])	# pick the first 200 genes after screening.
	y = as.numeric(Golub_Train$ALL.AML == "ALL")

#---	4.1 Using BEN

	ptm = proc.time()
	result.ben = GSL(x,y,lambda1=3,lambda2=1, itermax=10)
	time.leukemia = proc.time() - ptm
	save.image(file = "BENLeukemia.RData")

	ptm = proc.time()
	result.ben = GSL_BL(x,y,lambda1=3,lambda2=0.01, itermax=10)
	time.leukemia = proc.time() - ptm
	save.image(file = "BLLeukemia.RData")

#---	4.2 Results

	beta.ben = result.ben$beta
	
	intervals = NULL
	interval.prob = NULL
	level = 0.5
	for (i in 1:200) {
		#intervals = rbind(intervals, quantile(result.ben$beta[,i], probs = c(level/2, 1-level/2)))
		#intervals = rbind(intervals, c(-1,1))
		intervals = rbind(intervals, c(-1,1) * sqrt(var(result.ben$beta[,i])))
	}
	for (i in 1:200) {
		temp = ecdf(beta.ben[,i])
		interval.prob = c(interval.prob, temp(intervals[i,2]) - temp(intervals[i,1]))
	}
	vs.ben = data.frame(intervals, interval.prob)
	temp = order(vs.ben[,3])
	vs.ben = vs.ben[temp,]

#---	
	for (i in 1:8) {
		if((i-1)/4 == as.integer(i/4)) {
			x11()
			par(mfrow = c(2,2))
		}

		temp = result.ben$beta[,i]
		plot(density(temp),main=i)
		lines(sort(temp),dnorm(sort(temp),mean=mean(temp), sd=sqrt(var(temp))),col="red")
		temp.line = quantile(temp, probs = c(0.025, 0.975))
		abline(v = temp.line)

		#plot(result.ben$beta[,i], type="l")
		#acf(result.ben$beta[,i])
		#hist(result.ben$beta[,i])
	}

#---	4.3 Test data

	data(Golub_Test)
	x.all.test = exprs(Golub_Test)
	f = function(t) {
		t.test(t)$p.value
	}
	x.test = t(x.all.test[order(apply(x.all, 1, f))[1:200], ])	
	y.test = as.numeric(Golub_Test$ALL.AML == "ALL")

	sum((scale(x.test) %*% apply(beta.ben, 2, median) > 0.5) == y.test) / length(y.test)
