#---	5.5.1 BEN

	resid.ben = NULL	# to record the median squared errors
	bsm.ben = NULL		# short for beta.select.m.ben
				# to record how many times one predictor are excluded from the model using my criterion
	n.train = n.validation = 20*(sim.i %in% (1:2)) + 100*(sim.i == 4) + 20*(sim.i==5)
	for (i in 1:5) {
		load(paste("sim data\\sim_",sim.i,"\\ben\\ben", 10*i, ".Rdata", sep=""))
		x.train = x[1:n.train,]
		x.validation = x[(n.train + 1):(n.train + n.validation),]
		x.test = x[(n.train + n.validation + 1):(n.train + n.validation + n.test),]
		x.test.bar = scale(x.test)
		for (j in 1:10) {
			temp = as.numeric(names(table(y.ben[,2]))[j])
			y.temp = y.ben[which(y.ben[,2] == temp),][(n.train + n.validation + 1):(n.train + n.validation + n.test),1]
			y.temp.bar = y.temp - mean(y.temp)
			beta.temp = beta.ben[which(beta.ben[,p+1] == temp),][,-(p+1)]
			resid.ben = c(resid.ben, mean((y.temp.bar - x.test.bar %*% apply(beta.temp, 2, median))^2))

			intervals = NULL
			interval.prob = NULL
			for (ii in 1:p) {
			if (method == 1) intervals = rbind(intervals, quantile(beta.temp[,ii], probs = c(d/2, 1-d/2)))
			if (method == 2) intervals = rbind(intervals, c(-1,1))
			if (method == 3) intervals = rbind(intervals, c(-1,1) * sqrt(var(beta.temp[,ii])))
			}
			for (ii in 1:p) {
				temp = ecdf(beta.temp[,ii])
				interval.prob = c(interval.prob, temp(intervals[ii,2]) - temp(intervals[ii,1]))
			}
			if (method == 1) bsm.ben = rbind(bsm.ben, (intervals[,1] < 0 & intervals[,2] > 0))
			if (method == 3) bsm.ben = rbind(bsm.ben, (interval.prob > d))
		}
	}

	#---	the number of exclusions

	#	bsm.ben

	#---	the median and corresponding sd for resid.ben

	median(resid.ben)

	median.bsample = NULL
	for (b in 1:500) {
		bsample = sample(resid.ben, replace = T)
		median.bsample = c(median.bsample, median(bsample))
	}
	sd.ben = sqrt(var(median.bsample))

#---	5.5.2 BL

	resid.bl = NULL		# to record the median squared errors
	bsm.bl = NULL		# short for beta.select.m.bl
				# to record how many times one predictor are excluded from the model using my criterion

	for (i in 1:5) {
		load(paste("sim data\\sim_",sim.i,"\\bl\\bl", 10*i, ".Rdata", sep=""))
		x.train = x[1:n.train,]
		x.validation = x[(n.train + 1):(n.train + n.validation),]
		x.test = x[(n.train + n.validation + 1):(n.train + n.validation + n.test),]
		x.test.bar = scale(x.test)		
		for (j in 1:10) {
			temp = as.numeric(names(table(y.bl[,2]))[j])
			y.temp = y.bl[which(y.bl[,2] == temp),][(n.train + n.validation + 1):(n.train + n.validation + n.test),1]
			y.temp.bar = y.temp - mean(y.temp)			
			beta.temp = beta.bl[which(beta.bl[,p+1] == temp),][,-(p+1)]
			resid.bl = c(resid.bl, mean((y.temp.bar - x.test %*% apply(beta.temp, 2, median))^2))

			intervals = NULL
			interval.prob = NULL
			for (ii in 1:p) {
				if (method == 1) intervals = rbind(intervals, quantile(beta.temp[,ii], probs = c(d/2, 1-d/2)))
				if (method == 2) intervals = rbind(intervals, c(-1,1))
				if (method == 3) intervals = rbind(intervals, c(-1,1) * sqrt(var(beta.temp[,ii])))
			}
			for (ii in 1:p) {
				temp = ecdf(beta.temp[,ii])
				interval.prob = c(interval.prob, temp(intervals[ii,2]) - temp(intervals[ii,1]))
			}
			if (method == 1) bsm.bl = rbind(bsm.bl, (intervals[,1] < 0 & intervals[,2] > 0))
			if (method == 3) bsm.bl = rbind(bsm.bl, (interval.prob > d))
		}
	}

	#---	the number of exclusions

	#	bsm.bl

	#---	the median and corresponding sd for resid.bl

	median(resid.bl)

	median.bsample = NULL
	for (b in 1:500) {
		bsample = sample(resid.bl, replace = T)
		median.bsample = c(median.bsample, median(bsample))
	}
	sd.bl = sqrt(var(median.bsample))

#---	5.5.3 Using elastic net

	load(paste("sim data\\sim_", sim.i, "\\en and lars\\en.Rdata", sep=""))
	beta.en = beta.en[1:50,]

	#---	the number of exclusions
	apply(beta.en == 0, 2, sum)

	#---	the median and corresponding sd for resid.en
	median(resid.en)

	median.bsample = NULL
	for (b in 1:500) {
		bsample = sample(resid.en, replace = T)
		median.bsample = c(median.bsample, median(bsample))
	}
	sd.en = sqrt(var(median.bsample))

#---	5.5.4 Using lars

	load(paste("sim data\\sim_", sim.i, "\\en and lars\\lars.Rdata", sep=""))
	beta.lars = beta.lars[1:50,]

	#---	the number of exclusions
	apply(beta.lars == 0, 2, sum)
	
	#---	the median and corresponding sd for resid.en
	median(resid.lars)

	median.bsample = NULL
	for (b in 1:500) {
		bsample = sample(resid.lars, replace = T)
		median.bsample = c(median.bsample, median(bsample))
	}
	sd.lars = sqrt(var(median.bsample))
