#---	5.1 Simulation 1 data

if (sim.i == 1) {

	set.seed(12345)
	n.sim = 50				# number of data sets
	n.train = 20				# number of training replicates
	n.validation = 20			# number of validation replicates
	n.test = 200				# number of testing replicates
	p = 8					# number of parameters

	#---	Set beta.true and sigma.true

	beta.true = c(3, 1.5, 0, 0, 2, 0, 0, 0)
	sigma.true = 3

	#---	Get the x matrix	

	x.sigma = matrix(NA, p, p)
	rho = 0.5
	for(i in 1:p) {
		for (j in 1:p) {
			x.sigma[i,j] = rho^abs(i-j)
		}
	}
	x.train = mvrnorm(n=n.train, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x.validation = mvrnorm(n=n.validation, mu=rep(0,p), Sigma=x.sigma, empirical=T)	# This x is standardized.
	x.test = mvrnorm(n=n.test, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x = rbind(x.train, x.validation, x.test)
}

#---	5.2 Simulation 2 data
	
if (sim.i == 2) {

	set.seed(12345)
	n.sim = 50				# number of data sets
	n.train = 20				# number of training replicates
	n.validation = 20			# number of validation replicates
	n.test = 200				# number of testing replicates
	p = 8					# number of parameters

	#---	Set beta.true and sigma.true

	beta.true = rep(0.85, p)
	sigma.true = 3

	#---	Get the x matrix	

	x.sigma = matrix(NA, p, p)
	rho = 0.5
	for(i in 1:p) {
		for (j in 1:p) {
			x.sigma[i,j] = rho^abs(i-j)
		}
	}
	x.train = mvrnorm(n=n.train, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x.validation = mvrnorm(n=n.validation, mu=rep(0,p), Sigma=x.sigma, empirical=T)	# This x is standardized.
	x.test = mvrnorm(n=n.test, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x = rbind(x.train, x.validation, x.test)
}

#---	5.3 Simulation 3 data

if (sim.i == 3) {

	set.seed(12345)
	n.sim = 50				# number of data sets
	n.train = 100				# number of training replicates
	n.validation = 100			# number of validation replicates
	n.test = 400				# number of testing replicates
	p = 40					# number of parameters
	
	#---	Set beta.true and sigma.true

	beta.true = c(rep(0, 10), rep(2, 10), rep(0, 10), rep(2, 10))
	sigma.true = 15

	#---	Get the x matrix	

	x.sigma = matrix(NA, p, p)
	rho = 0.5
	for(i in 1:p) {
		for (j in 1:p) {
			x.sigma[i,j] = rho
		}
	}
	x.train = mvrnorm(n=n.train, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x.validation = mvrnorm(n=n.validation, mu=rep(0,p), Sigma=x.sigma, empirical=T)	# This x is standardized.
	x.test = mvrnorm(n=n.test, mu=rep(0,p), Sigma=x.sigma, empirical=T)		# This x is standardized.
	x = rbind(x.train, x.validation, x.test)
}

#---	5.4 Simulation 4 data

if (sim.i == 4) {

	set.seed(12345)
	n.sim = 50				# number of data sets
	n.train = 100				# number of training replicates
	n.validation = 100			# number of validation replicates
	n.test = 400				# number of testing replicates
	p = 30					# number of parameters

	#---	Set beta.true and sigma.true

	beta.true = c(rep(3, 5), rep(3,5), rep(3,5), rep(0, 15))
	sigma.true = 15

	#---	Get the x matrix	

	z1 = rnorm(1)
	z2 = rnorm(1)
	z3 = rnorm(1)
	x.train = x.validation = x.test = NULL
	for (i in 1:n.train) {
		x.train = rbind(x.train, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	for (i in 1:n.validation) {
		x.validation = rbind(x.validation, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	for (i in 1:n.test) {
		x.test = rbind(x.test, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	x.train = scale(x.train)
	x.validation = scale(x.validation)
	x.test = scale(x.test)
	x = rbind(x.train, x.validation, x.test)
}

#---	5.5 Simulation 5 data

if (sim.i == 5) {
	set.seed(12345)
	n.sim = 50				# number of data sets
	n.train = 20				# number of training replicates
	n.validation = 20			# number of validation replicates
	n.test = 400				# number of testing replicates
	p = 30					# number of parameters

	#---	Set beta.true and sigma.true

	beta.true = c(rep(3, 10), rep(0,10), rep(3,10))
	sigma.true = 15

	#---	Get the x matrix	

	z1 = rnorm(1)
	z2 = rnorm(1)
	z3 = rnorm(1)
	x.train = x.validation = x.test = NULL
	for (i in 1:n.train) {
		x.train = rbind(x.train, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	for (i in 1:n.validation) {
		x.validation = rbind(x.validation, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	for (i in 1:n.test) {
		x.test = rbind(x.test, c(rnorm(5,mean=z1,sd=0.1), rnorm(5,mean=z2,sd=0.1), rnorm(5,mean=z3,sd=0.1), rnorm(15)))
	}
	x.train = scale(x.train)
	x.validation = scale(x.validation)
	x.test = scale(x.test)
	x = rbind(x.train, x.validation, x.test)
}
